* LBINCR.PRG
* incremental search for a record
* fldlist = field list for browse. You can use all
*           field clauses including :H :P :#, etc.
*           You can also include calculated fields!
* defsrch = Default value to srch; if none 
*           supplied, defaults to "". 
* toprow  = top row for search window, defaults to 1
* topcol  = top left column for search window, 
*           defaults to 0
* bottrow = bottom row for search window, 
*           defaults to 20
* bottcol = bottom right column for search window, 
*           defaults to 50
PARAMETERS fldlist,defsrch,toprow, ;
topcol,bottrow,bottcol
PRIVATE oldsele,oldnear,wasincr,oldbell
defsrch=IIF(TYPE('defsrch')="C",UPPER(defsrch),"")
toprow=IIF(TYPE('toprow')="N",toprow,1)
topcol=IIF(TYPE('topcol')="N",topcol,0)
bottrow=IIF(TYPE('bottrow')="N",bottrow,20)
bottcol=IIF(TYPE('bottcol')="N",bottcol,50)
oldnear=SET('near')  && save old near setting
SET NEAR ON          && need near on for search
oldbell=SET('bell')  && save old bell setting
SET BELL OFF         && active bell is annoying 
                     && and slows system
** create background window
DEFINE WINDOW incrsrch FROM toprow,topcol ;
TO bottrow,bottcol SHADOW FLOAT CLOSE ;
TITLE "Incremental Search" system
** make background window active
ACTIVATE WINDOW incrsrch  
** create window for refreshing the browse
DEFINE WINDOW refresh FROM 0,0 TO 0,0 NONE
** create window for display of current entry value
DEFINE WINDOW cursrch IN WINDOW incrsrch ;
FROM 0,0 TO 0,bottcol-topcol-2 NONE COLOR SCHEME 7
ACTIVATE WINDOW cursrch IN WINDOW incrsrch
@ 0,0 SAY "Search for M"
@ 0,14 SAY defsrch
** create window for use by browse window
DEFINE WINDOW lookup IN WINDOW incrsrch ;
FROM 1,0 TO bottrow-toprow-2,;
bottcol-topcol-2 SYSTEM COLOR ;
BG+/N,N/N,n/n,BG+/N,N+/W,B/W,BG+/R,G+/N,GR+/W,N+/W,+  
oldsele=select() && save number, original work area
** open the "magic" one-record, one-field, 
** one-character database
wasincr=.t.
IF !used('incremen')
  wasincr=.f.
  SELECT 0
  USE incremen
ENDIF
** select the original work area
SELECT (oldsele)
** find the default search value
cursrch=defsrch
SEEK cursrch
** browse the original work area
** the first field is the same for all records
BROWSE FIELDS ;
incremen->char:p="!":v=incr1( ;
incremen->char):h="":1,;
&fldlist. freeze incremen->char ;
WINDOW lookup IN WINDOW incrsrch NOWAIT ;
SAVE TITLE "INCREMENT"
ON KEY LABEL backspace DO incr2 && handle back space
ON KEY LABEL enter keyboard chr(23) ;
plain  && close browse window
DO WHILE .T.
  ** give the BROWSE LAST command a window to use
  SHOW WINDOW INCREMENT in window incrsrch TOP
  BROWSE LAST
  newtop=wontop()
  DO CASE
    CASE !wexist('increment').or. ;
    !wvisible('increment')
      ** closed the browse window
      EXIT
    CASE newtop="CURSRCH"
      ** clicked on the window that displays current
      ** content of search string
      ON KEY LABEL backspace
      ON KEY LABEL enter
      ACTIVATE WINDOW cursrch IN WINDOW incrsrch
      cursrch=padr(cursrch,80)
      ** let user enter entire string
      @ 0,14 GET cursrch PICTURE "@!"
      READ
      cursrch=TRIM(cursrch)
      SEEK cursrch
      ON KEY LABEL backspace DO incr2 
      ON KEY LABEL enter keyboard chr(23) ;
      plain  && close browse window
    OTHERWISE
      ** display value being searched
      ACTIVATE WINDOW cursrch IN WINDOW incrsrch
      @ 0,14 SAY cursrch
      ** find the closest match for the character
      SEEK cursrch
  ENDCASE
ENDDO              
ON KEY LABEL backspace
ON KEY LABEL enter          
IF !wasincr
  USE in incremen
ENDIF incremen database was not in use
IF oldnear#"ON"
  SET NEAR OFF
ENDIF
IF oldbell#"OFF"
  SET BELL ON
ENDIF
IF WEXIST('incrsrch')
  RELEASE WINDOW incrsrch
ENDIF
IF WEXIST('refresh')
  RELEASE WINDOW refresh
ENDIF
RETURN
* eop lbincr.prg 

PROCEDURE incr1
** accumulate characters into cursrch
PARAMETERS thischar
cursrch=cursrch+thischar
REPLACE incremen->char WITH chr(255)
ACTIVATE WINDOW REFRESH && exit BROWSE session
RETURN .T.

PROCEDURE incr2
** called when user hits backspace
** remove last character from cursrch
cursrch=LEFT(cursrch,LEN(cursrch)-1)
ACTIVATE WINDOW REFRESH && exit BROWSE session
RETURN


